<?php

declare(strict_types=1);

namespace App\Entity\Place;

use ApiPlatform\Metadata\ApiResource;
use App\Entity\Access\Access;
use App\Entity\Core\AbstractRepair;
// use DH\Auditor\Provider\Doctrine\Auditing\Annotation\Auditable;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @todo : A la suite de la migration, il faut supprimer le nom de la table pour avoir une table PlaceRepair, et supprimer l'attribut discr.
 * @todo : migration table tag_repair
 *
 * Réparation effectuée sur un lieu (Place)
 */
// #[Auditable]
#[ApiResource(operations: [])]
#[ORM\Entity]
class PlaceRepair extends AbstractRepair
{
    #[ORM\ManyToOne(inversedBy: 'placeRepairProviders')]
    #[ORM\JoinColumn(referencedColumnName: 'id', nullable: true, onDelete: 'SET NULL')]
    protected ?Access $provider = null;

    #[ORM\ManyToOne(inversedBy: 'repairs')]
    protected ?Place $place = null;

    public function __construct()
    {
        $this->tags = new ArrayCollection();
    }

    public function getProvider(): ?Access
    {
        return $this->provider;
    }

    public function setProvider(?Access $provider): self
    {
        $this->provider = $provider;

        return $this;
    }

    public function getPlace(): ?Place
    {
        return $this->place;
    }

    public function setPlace(?Place $place): self
    {
        $this->place = $place;

        return $this;
    }
}
